import 'package:flutter/cupertino.dart';
import 'package:osam/domain/state/base_state.dart';

typedef Reducer<ST extends BaseState<ST>> = BaseState Function(ST state);

class Event<ST extends BaseState<ST>> {
  final Reducer<ST> reducer;

  const Event({@required this.reducer});

  void call(ST state) => reducer?.call(state)?.update();

  String get log => toString();
}
