import 'package:osam/domain/event/event.dart';
import 'package:osam/domain/state/base_state.dart';
import 'package:osam/domain/store/store.dart';

typedef Condition<ST extends BaseState<ST>> = void Function(Event<ST> event);

abstract class Middleware<ST extends BaseState<ST>> {
  Store<ST> store;

  List<Condition<ST>> get conditions;

  bool nextEvent(bool next) => next;

  @override
  bool operator ==(Object other) => runtimeType == other.runtimeType;

  @override
  int get hashCode => runtimeType.hashCode;
}
